SteinBlume. CP/M Disk Image Explorer. История версий.

+ Добавлена новая функция.
* Изменена функция / Исправлена ошибка.

v1.3.2.1410 (17.02.2019)
* Отключена валидация параметров "Число цилиндров" и "Число секторов на одной дорожке";
* Добавлена возможность группового изменения атрибутов выделенных файлов.

v1.3.0.1408 (7.11.2017)
+ Добавлена экспериментальная "прямая" поддержка образов дисков Amstrad DSK;
+ В "Настройках" добавлена возможность выбора языка интерфейса по умолчанию, со сменой "на лету";
Параметры командной строки для принудительного выбора языка (-l ru или --lang ru) также сохранены.
* Исправлена ошибка, не позволяющая в некоторых случаях сохранить образ диска с числом блоков менее 256;
+ Lister. Добавлен просмотр графических файлов BLK, созданных в пакете GRAF для ATM (Большое спасибо Максиму Тимонину за помощь);
+ Lister. При просмотре Spectrum BASIC добавлена возможность включения/отключения отображения контрольных (непечатных) кодов, реальных значений чисел;
В "Настройках" добавлена возможность настройки отображения по умолчанию.
+ Lister. Добавлены режимы просмотра дизасма в мнемониках Intel 8080 и Z80;
Для COM-файлов CP/M и кодовых файлов +3 DOS эти режимы используются, как режимы просмотра по умолчанию. В "Настройках" также появились опции, касающиеся этих режимов просмотра.
* Lister. Исправлена ошибка просмотра в режиме текста для +3 DOS;
* Мелкие исправления.

v1.2.1.1401 (1.09.2017)
+ Lister. Добавлена поддержка просмотра графических файлов GRF с палитрой (Profi);
* Разные мелкие изменения;
* Исправлены мелкие ошибки.

v1.2.0.1400 (8.03.2017)
+ Добавлен диалог Свойств образа (Alt+Enter);
+ Добавил возможность открытия файла образа диска, передав его имя в качестве параметра командной строки (Спасибо barsik'у за замечание);
+ Добавил возможность сохранять последние пути операций Открытия/Сохранения образа, Извлечения/Добавления файла в образ;
Добавил опцию в Настройки. По умолчанию включена.
+ Добавил Ctrl+A для выделения/снятия выделения для всех файлов;
Курсор при этом не обязательно должен находится в списке файлов.
+ Добавлена функция подсчета неиспользуемого места в последних блоках файлов;
См. соответствующий пункт в меню. Подскажите горячую клавишу - добавим.
+ Добавил создание образа диска Орион по заданным пользователем параметрам;
Для этого при создании образа надо вместо файла системы выбрать пункт Настроить. После чего откроется диалог, где можно ввести все необходимые параметры, либо выбрать один из 4 вариантов предустановки.
(За эти четыре обновления скажем спасибо barsik'у).
+ В Настройки добавлены четыре опции для +3;
+ Для +3 добавлена возможность добавить заголовок к существующему файлу;
+ Поддержка образов HDD Ориона (кроме создания);
При открытии образа диска оригинальный файл образа автоматически бэкапится (это можно отключить в настройках, но пока крайне не рекомендую), а вся работа происходит с копией образа. Все дело в том, что работа утилиты с образом HDD происходит несколько иначе, чем с образами FDD. Образа FDD грузятся в память целиком, после чего все манипуляции происходят именно там, а оригинальный образ остается нетронутым, пока не будет использована функция сохранения. Работа же с образом HDD идет напрямую в файле образа, то есть все действия (удаление/переименование файлов, добавление файлов,...) происходят сразу в образе и сохранения образа не требуют. Кроме того, работа с HDD на данный момент достаточно сыра. Поэтому на всякий случай рекомендую не отключать опцию бэкапа.
+ При извлечении файлов из образа, символы имени файла теперь тоже проверяются на допустимость;
Символ для замены недопустимых символов добавлен в Настройки.
+ При добавлении в образ файлов с кириллическими именами, такие имена теперь корявенько так транслитируются :)
+ Добавлена опция игнорирования "удаленных" файлов при открытии образа (отключена по умолчанию);
В некоторых случаях наличие "удаленных" файлов в образе может вызывать ошибку при попытке открыть образ. Попробуйте использовать эту опцию. 
+ Добавлена возможность перетаскивания файлов мышью из SteinBlume наружу (в проводник, в другие приложения или в другой открытый экземпляр SteinBlume);
В результате немного поменялась логика работы при перетаскивании файлов между областями пользователя. Теперь сменить режим переноса/копирования (Shift) можно в любой момент до отпускания кнопки мыши (что логичнее и удобнее). Изменился вид курсоров для этих операций на стандартный для Windows.
* Изменена горячая комбинация для открытия диалога настроек (Ctrl+Enter);
* Изменение обработки ошибок при открытии файла;
При открытии образа, если формат образа неопознан, теперь можно выбрать вариант дальнейших действий:
- открыть образ, используя параметры предыдущего образа (если ранее ничего не открывалось, используются параметры по умолчанию),
- открыть образ, используя параметры по умолчанию,
- открыть образ как .xdi (ввести параметры образа).
* Изменение обработки ошибок при открытии файла;
Теперь при ошибке превышения маскимального номера блока, операция открытия образа не прерывается. Обработка записи в директории, вызвавшей ошибку пропускается. В конце операции открытия выводится список произошедших при открытии ошибок (опционально, по умолчанию вывод ошибок отключен).
* Исправлена ошибка создания образа диска;
Проявлялась в невозможности сохранить образ.
* Исправлено открытие образов Скорпиона (сломал в версии 1101386);
* Lister: Исправлена работа выбора кодировки при сохранении текста из Lister;
* Lister. Теперь кодировка текста определяется автоматически (можно отключить в Настройках);
* Lister. Изменена горячая комбинация для кодировки АТМ (Ctrl+M);
* Lister. Исправлено отображение табуляции;
* Lister. Исправлен просмотр изображений WIN (Корвет).
Были перепутаны цвета.
* Исправлены мелкие ошибки. 

v1.1.1.1388 (25.07.2016)
* Починена функция переноса/копирования файлов между областями пользователей, поломанная в v1.0.0.1373 (12.04.2016). Спасибо KTSerg за баг-репорт.

v1.1.0.1386 (23.07.2016)
* Исправлена ошибка при сохранении образов Байт-01;
* Исправлено переименование;
Нажатие клавиши Del при переименовании теперь не вызывает функцию удаления файла.
* Исправлена функция добавления файлов в образ перетаскиванием;
Теперь при добавлении в образ группы файлов, сообщение о нехватке места выводится только один раз, а не для каждого файла, а при совпадении имен нажатие "Отмены" вызывает отмену всей операции.
* Изменена функция "Открыть образ как .xdi";
Теперь с помощью этой функции можно попробовать открыть файл с любым расширением.
* Изменена функция извлечения файла;
Ранее нельзя было извлечь файл, в имени которого имеются недопустимые символы. Теперь такие символы автоматически заменяются специальным символом, заданным в Настройках.
* Исправлены мелкие ошибки, добавлены новые;
+ Lister: Добавлен просмотр графических файлов Вектор-06Ц. Спасибо KTSerg, Ивану Городецкому (ivagor), AzAtom, PRSoft;
Поддержаны следующие форматы файлов:
 - BSV - дамп экрана Вектор-06Ц. На данный момент поддержан только режим 256х256 пикселей. Если на диске (в той же области пользователя, что и сам файл) также хранится файл палитры (должен иметь тоже имя, что и у файла изображения, а расширение "PAL"), то при просмотре будет использована палитра из этого файла, в противном случае будет использована палитра BASIC 2.5;
 - RBR / RMB - файлы редактора "Рембрандт";
 - SCR - файлы редактора "Карандаш". Поддержано расширение от PRSoft - возможность использование внешнего файла палитры, имя которого должно быть прописано в самом файле изображение вместо номера телефона автора редактора "Карандаш" (байты 05-0F) и дополнено пробелами. ВНИМАНИЕ! ДАННАЯ ВОЗМОЖНОСТЬ НЕ ТЕСТИРОВАЛАСЬ НА РЕАЛЬНЫХ ФАЙЛАХ! В случае отсутствия ссылки на палитру (стандартный формат), используется палитра BASIC 2.5;
 - SPR - файлы редактора "Draw".
+ Lister: Добавлен просмотр дампа экрана Корвета;
Детектятся по размеру.
+ Lister: Добавлен просмтор графических файлов редактора "Grin" (Корвет);
Поддержаны следующие форматы файлов:
 - PIC - дамп экрана Корвета;
 - GRF - запакованный дамп экрана Корвет;
 - WIN - окно (участок экрана Корвет).
+ Lister: Добавлен просмотр графический файлов редактора "Абрис" (Расширение .ABR) (Корвет).

v1.0.0.1373 (12.04.2016)
(*) Проект переименован в SteinBlume. CP/M Disk Image Explorer;
(*) Просмотрщик переименован в Lister, аналогично Lister'у в Total Commander by Christian Ghisler;
Не существенно, но здесь и в других местах я буду называть его именно так (мне так проще).
+ Добавлена поддержка образов fdd, как образов CP/M Вектор-06Ц. Возможны неточности.
+ Добавлена горячая клавиша Del для удаления файла(ов). F8 также работает.
+ Добавлен инструмент Карта образа диска (Ctrl + M). Внимание! По причине специфики работы утилиты карта правильно отображает только оригинальное расположение файлов в образе до редактирования образа. 
  Функционал: 
  - При выборе файла из списка слева, на карте выделяются занятые им блоки, карта прокручивается так, чтобы первый блок занимаемый файлом отобразился в поле видимости, внизу окна выводится информация о файле, список номеров занимаемых им блоков и информация о первом блоке, занятом этим файлом;
  - При одинарном щелчке на карте, выделяется блок и выводится информация о блоке;
  - При двойном щелчке на карте, если блок занят файлом, происходит то же, что и при выборе файла из списка, но карта не прокручивается, если блок файлом не занят, реакция аналогична одинарному щелчку.
+ Редактор заголовков файлов для образов +3 DOS;
* Изменена реакция на номер блока в директории, превышающий максимальное значение. Теперь, если данный номер встречается в карте расположения "удаленного" файла, размер такого файла приравнивается 0 (возможно стоит исключать из списка), а  дальнейшая обработка образа не прерывается с ошибкой (как было ранее), а продолжается дальше;
+ Для PLUS3DOS добавил вывод типа файла в списке файлов образа;
+ Добавлена функция поиска ASCII-строки / последовательности байт в файлах образа (Ctrl + F). Выдает список файлов с найденным образцом и смещение относительно начала файла. Возможен просмотр найденных файлов в Lister'е (F3);
* Исправлены мелкие косяки интерфейса;
* Переписана заново функция открытия образа. Возможны новые глюки:) Теперь открываются образы с программным смещением секторов (software skewed sectors);
Подробнее про программное смещение секторов: По сути это обычный интерлив, то есть сектора дорожки обрабатываются не в порядке следования, а с некоторым смещением (например: 1, 3, 5, 7, 9, 2, 4, 6, 8, 10). Отличительной особенность ПРОГРАММНОГО смещения является то, что на дискете номера секторов оставались прежними, то есть чтение номеров секторов из заголовка на дискете не дает никакой информации о том, в каком порядке сектора обрабатываются на самом деле. В результате образы, полученные с таких дисков, получаются "перемешанными". Информацию о том, в каком порядке производить чтение/запись, ОС хранит в специальной таблице. Логично предположить, что системные дорожки "не перемешивались", поэтому текущая версия утилиты их "не упорядочивает", только сектора дорожек идущих после системных. Все вышесказанное является всего лишь результатом моих домыслов и может абсолютно не соответствовать действительности. Поэтому прошу, если что, меня поправить.
* Переписана заново функция сохранения образа. Возможны новые глюки:)
* Незначительно переписана функция добавления файла в образ. О возможных последствиях смотрим выше:)
* Незначительно переписана функция извлечения файла из образа. О возможных последствиях смотрим выше:)
* Незначительно переписана функция создания нового образа. О возможных последствиях смотрим выше:)
* Незначительно переписана функция сохранения системных дорожек. О возможных последствиях смотрим выше:)
+ Добавлен параметр xdi "format_id" - замена и дополнение расширению файла, строка указывает утилите на дополнительные свойства присущие именно данному формату. Данные строки прописываются в коде программы в виде констант. В данной версии обрабатывается только одна такая константа (format_id=PLUS3DOS), указывающая на то, что образ должен быть обработан, как образ +3 DOS.
+ Добавлен параметр xdi "date_stamp", указывающий на формат хранения дат файлов в директории. Может принимать 3 значения:
  0 - (по умолчанию) формат не поддерживает хранение дат файлов,
  1 - даты файлов хранятся по стандарту CP/M,
  2 - нестандартный (для CP/M) формат хранения дат (используется например в Z80DOS и DOS+).
В данной версии поддержка дат не реализована. Образа, использующие сохранение дат, при установленном параметре 1 или 2, открываются корректно, однако сами даты нигде не отображаются и в последствии в образ не сохраняются.
* Изменено трактовка параметра dsm (-> BlNo-1). На работе программы данный параметр не отразился, так как не используется при обработке образа.
+ Добавлена кнопка "Запомнить" в диалог "Параметры .xdi" для сохранения введенных значений в качестве значений по умолчанию.
+ Добавлена кнопка "Восстановить" для восстановления значений по умолчанию из настроек в диалог "Параметры .xdi" и изменена логика хранения значений этого диалога. Теперь введенные пользователем значения не заменяются при каждом открытии диалога на значения по умолчанию.
+ Добавлен режим простого редактирования параметров диска в диалогах "Параметры .xdi" и "Настройки - Параметры .xdi";
* Исправлена работа с образами дисков, размер Экстента которых больше 16k;
+ Добавлена возможность загрузки/сохранения параметров xdi из файла/в файл в диалогах "Параметры .xdi" и "Настройки - Параметры .xdi";
* Исправлена обработка 1-байтной карты;
* Изменена логика подсчета свободного места;
Теперь величина свободного места вычисляется исходя из числа секторов и дорожек образа, а не из размера исходного файла образа. Это, во-первых, исключает из объема диска "лишние" дорожки (дискету часто можно было отформатировать на большее число дорожек, однако, для CP/M эти дорожки оставались не видимы), во-вторых, позволяет корректно отображать свободное место для образов, с обрезанными пустыми дорожками. Во втором случае (если файл образа меньше типичного) выдается соответствующее предупреждение.
* Доделан диалог настроек.
+ Добавлена (возвращена) поддержка ZS Scorpion;
+ Lister: Добавлен просмотр BASIC для образов Корвета;
+ Lister: Добавлен просмотр изображений формата .ZAS для образов Корвета;
+ Lister: Добавлен режим полного просмотра;
Актуален пока только для файлов Plus3DOS. Для них при включенном режиме отображается файл целиком (вместе с заголовком и "мусором в хвосте") (Ctrl + V).
+ Lister: Добавлена кодировка КОИ7: Н1 и Н2 (Ctrl + 1, Ctrl + 2);
+ Lister: Добавлена функция поиска текста (Ctrl + F);
* Lister: Теперь Lister работает в многооконном режиме;
+ Lister: Добавлен просмотр BASIC для +3;
Для остальных (не BASIC) файлов, при просмотре отображается только реальная часть, согласно содержимому заголовка +3.
+ Lister: Добавлен просмотр экранных файлов (как с атрибутами, так и без) для +3 из файлов с заголовком +3 DOS и без. Пока минимум функций:
  - Масштабирование клавишами "-" и "+",
  - Включение/отключение атрибутов (кл. A),
  - Циклический перебор цветов INK, PAPER (кл. I, P) для режима "без атрибутов", BORDER (кл. B),
  - Смена цветовой палитры клавишей C (пока в программе реализовано 2 палитры: цветная и псевдомонохромная),
  - Сброс цветовых настроек (кл. R),
  - Экспорт в scr, png, bmp, hobeta. 
Поддержка FLASH пока не реализована.
* Lister: Исправлена ошибка отображения текста в Lister;
+ Disk Image Analyzer v2.2: Добавлена поддержка DSK.
+ KDI Checksum Reader: Добавлен экспорт параметров DPB, DPH напрямую в SteinBlume, в диалог параметров xdi.
Функция не имеет практического применения и, возможно, уже не работает:)

v0.5.1.1362 (7.09.2015)
+ Добавлен Splitter между списком USER и списком файлов;
* Исправлены ошибки GUI при изменении размера окна (Спасибо Creator'у за баг-репорт);
* Исправлены мелкие ошибки GUI.

v0.5.0.1361 (6.09.2015)
* Изменения в меню "Инструменты". Утилиты FDI Analyzer и Teledisk Analyzer заменены универсальной Disk Image Analyzer;
* Удалены все зачатки поддержки FDI и Teledisk. Теперь эти функции вынесены в Disk Image Analyzer;
* Исправлены ошибки отображения GUI;
* History_ru.txt вернул в кодировку CP1251.

v0.4.1.1360 (30.08.2015)
+ Добавлена поддержка мультиязычности;
+ Добавлен пункт меню "Инструменты" для запуска дополнительных утилит, если они установлены;
* Немного ускорен просмотрщик.

v0.4.0.1359 (26.08.2015)
+ Добавлена поддержка пользовательского (экспериментального) формата файлов (xdi).
Введено понятие так называемого файла xdi (eXperimental Disk Image или просто X Disk Image). Теперь подробнее. В утилиту добавлена возможность открытия (создания, изменения, сохранения) образов, не поддерживаемых "из коробки". Для этого пользователю нужно знать (грамотно подобрать) параметры DPH и DPB. Далее для открытия файла возможно 2 пути: либо сменить расширение файла образа на ".xdi" и открыть образ как обычно, либо воспользоваться пунктом меню "Открыть образ как .xdi". После чего ему будет предложено заполнить параметры DPH и DPB (значения по умолчанию задаются в настройках). Затем файл образа будет открыт как любой другой. Проверка на адекватность введенных данных не производится, поэтому рекомендую использовать данную функции крайне осторожно. Вот и все.

v0.3.2.1356 (5.03.2014)
+ Добавлена поддержка Байт-01 (спасибо за это скажем нашему товарищу из Польши - Gelip).
* Небольшие косметические изменения в "О программе" (теперь прямо оттуда можно прыгнуть на форум zx.pk.ru).

v0.3.1.1355 (1.03.2014)
@ Реанимирована работа над утилитой.
+ По просьбам трудящихся (а именно Djoni) наконец-то добавлена возможность добавления файлов в образ при перетаскивании группами (не по одному, как было раньше).

v0.3.1.1354 (9.09.2012)
* Изменен подсчет свободного места.
Раньше вычисление свободного места производилось в корне неправильно. Вычислялось оно исходя из объема диска и последнего занятого блока. Это приводило к ошибке, если файлы располагались не подряд, если между ними встречались незанятые блоки. Теперь при подсчете учитываются только реально занятые блоки. Кроме того, теперь не учитывается место, занимаемое "удаленными" файлами.
* Изменена работа с "удаленными" файлами.
Теперь при сохранении образа "удаленные" файлы не сохраняются, о чем выводится предупреждение. При необходимости их можно восстановить путем переноса в любую область пользователя. Дело в том, что из-за особенностей работы утилиты, их сохранение могло привести к переполнению образа (каждый "удаленный" файл занимал свое собственное дисковое пространство).
+ В настройки добавлен выбор кодировки (Ansi/UTF-8) при сохранении файла из просмотрщика.
+ Добавлены горячие клавиши в режим просмотра.
* Исправлена ошибка отображения окна редактирования при переименовании файла.
При включенной панели инструментов, окошко позиционировалось выше, чем надо. Ошибка появилась несколько версий назад, благодаря исправлению другой, а замечена была мной пару дней назад.
* Исправлено отображение полосы прокрутки.

v0.3.0.1353 (8.08.2012)
+ Добавлена функция сохранения файлов, как текстов из режима просмотра. Спасибо Djoni за идею.

v0.3.0.1352 (2.06.2011)
* Исправил обработку больших файлов для Корвета.
В качестве образца был использован образ с Англо-русским словарем.
* Косметическое изменение в функции просмотра.
Теперь в заголовке окна просмотра, также отображается номер области пользователя, а имя файла отображается без лишних пробелов.
* Еще одно косметическое изменение в функции просмотра.
Теперь при смене режима просмотра (текст/hex) и при смене кодировки нужная кнопка на панели зажимается. Таким образом всегда видно, какая кодировка (и какой режим) является текущей.

v0.3.0.1340 (31.05.2011)
+ Добавлены некоторые горячие клавиши;
+ Добавлена проверка на максимально допустимый номер блока.
На данный момент выдается сообщение об ошибке и обработка образа прекращается (возможно, лучше будет обрабатывать, например, максимально допустимый блок);
+ Добавлена кодировка Iso;
+ Выбор системы при создании образа.
Выбираете компьютер и файл системы из списка (файлы системы должны располагаться в папке /sys/<компьютер> и иметь расширение .bin. Это может быть любой не кривой образ или только системные дорожки);
+ Добавлена возможность сохранение системных дорожек.
Появился дополнительный пункт в меню "Действия". Недоступен для АТМ, Profi (так как во всех АТМ-овских образах, которые мне встречались, системная область пустая, а в Profi ее вообще нет) и Scorpion, так как она, похоже (поправьте, если нет), везде одна.
* Исправлены мелкие ошибки.
На данный момент поддерживаются: АТМ, Профи, Корвет, Орион, Кворум, Скорпион (глючно).

v0.2.3.792 (06.11.2010)
+ Добавлена кодировка Profi при просмотре файла;
+ Добавлена операция копирования файлов внутри образа с помощью drag'n'drop с зажатым shift;
+ Добавлена проверка на существование файла с тем же именем в области пользователя в операциях переноса/копирования файлов внутри образа, переименования файла, добавления файла в образ;
* При переименовании файлов теперь разрешены оба регистра, так как были найдены образы с именами файлов в нижнем регистре;
* Исправлена ошибка просмотрщика. Раньше после просмотра файла в 16-ричном режиме и переключения в текстовый при смене кодировки, режим просмотра возвращался к 16-ричному;
* Удалено мерцание при просмотре файлов в hex-режиме;
* Исправлена ошибка добавления файла в образ. Для добавляемых файлов не вычислялась crc32;
* Исправлена обработка образов, имеющих больше 16 областей пользователя;
* Исправлены мелкие ошибки.

v0.2.2.602 (28.10.2010)
+ Добавлен перенос файлов из одной области User в другую перетаскиванием. Таким же образом можно восстанавливать удаленные файлы;
+ Добавлен 16-ричный режим просмотра файлов;
+ Добавлены кодировки при просмотре файла: OEM/DOS (CP866), Windows (CP1251);
* Исправлена ошибка отображения псевдографики в режиме просмотра файла;
* Исправлена ошибка операции добавления файла. При добавлении файла в только что созданный образ возникала ошибка 'Out of bounds';
* Исправлена ошибка в файле History.txt. Предыдущая версия программы ошибочно датировалась 27.10.2010 вместо 24.10.2010.:)

v0.2.1.396 (24.10.2010)
+ Добавлена обработка удаленных файлов (User Deleted);
+ Добавлено вычисление CRC32 для всех файлов образа;
+ Добавлен диалог настроек;
* Пустые User теперь выделяются другим цветом;
* Переработан механизм переименования файлов (теперь эта операция происходит более наглядно);
* Изменена обработка тел файлов (теперь размер файла берется из количества занимаемых блоков);
* Исправлена обработка имен файлов (Теперь имена файлов обрезаются до размеров 8.3. Используется только верхний регистр (символы нижнего регистра автоматом переводятся в верхний), недопустимые символы и символы кириллицы (их список можно изменить в настройках) заменяются на специальный символ (меняется там же));
* Исправлены мелкие ошибки и недочеты.

v0.2.0.152 (17.10.2010)
+ Добавлена поддержка USER (Также добавлен юзер с загадочным именем All);
+ Добавлена сортировка по клику на заголовке столбца таблицы файлов.

v0.1.0.29 (15.10.2010)
+ Добавлено расширение .atm;
* Исправлена ошибка открытия образов, если программа запущена из папки с кириллическим именем.

v0.1.0.21 (13.10.2010)
+ Добавил открытие образа перетаскиванием на форму, и добавление файла (если образ - открывается образ, если нет - добавляется файл в открытый образ);
* Исправлена ошибка просмотра файла из образа (F3);
* Исправлена ошибка сохранения образа, теперь измененный образ сохраняется в папку, из которой он был открыт, а не в папку, откуда запущена программа.

v0.1.0.1 (12.10.2010)
+ Первая public beta версия.

(c) 2010 - 2016 Black Cat / ERA Creative Group
era_cg@speccy.su